'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _focusTrap = require('../helpers/focusTrap');

var _focusTrap2 = _interopRequireDefault(_focusTrap);

var _focusManager = require('../helpers/focusManager');

var focusManager = _interopRequireWildcard(_focusManager);

var _styles = require('../helpers/styles');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TAB_KEY = 9;
var ESC_KEY = 27;

var OffCanvas = function (_Component) {
  _inherits(OffCanvas, _Component);

  function OffCanvas() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, OffCanvas);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = OffCanvas.__proto__ || Object.getPrototypeOf(OffCanvas)).call.apply(_ref, [this].concat(args))), _this), _this.buildStyles = function () {
      var isOpen = _this.props.isOpen.isOpen;


      return {
        canvas: {
          height: '100%',
          width: '100%',
          background: 'rgba(0, 0, 0, 0.5)',
          left: 0,
          position: 'fixed',
          transform: isOpen ? '' : 'translateX(-100%)',
          transition: 'all 0.5s'
        }
      };
    }, _this.buildPush = function () {
      var isOpen = _this.props.isOpen.isOpen;


      var el = document.querySelector('#content');
      if (el) {
        el.style.transform = isOpen ? 'translateX(100%)' : '';
        el.style.transition = 'all 0.5s';
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(OffCanvas, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.props.isOpen && !prevProps.isOpen) {
        this.buildStyles;
        this.buildPush();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var styles = this.buildStyles();
      this.buildPush();

      return _react2.default.createElement(
        'div',
        { style: styles.canvas },
        this.props.children
      );
    }
  }]);

  return OffCanvas;
}(_react.Component);

/* export default class OffCanvas extends Component {
  static defaultProps = {
    isOpen: false,
    width: '300px',
    height: '300px',
    position: 'left',
    closeOnEsc: true,
    closeOnOverlayClick: true,
    trapFocusAfterOpen: true,
    returnFocusAfterClose: true,
    style: {
      overlay: {},
      content: {},
    },
  };

  static propTypes = {
    isOpen: PropTypes.bool.isRequired,
    width: PropTypes.string,
    height: PropTypes.string,
    position: PropTypes.oneOf(['left', 'right', 'top', 'bottom']),
    mainContainerSelector: PropTypes.string,
    onClose: PropTypes.func,
    closeOnEsc: PropTypes.bool,
    closeOnOverlayClick: PropTypes.bool,
    trapFocusAfterOpen: PropTypes.bool,
    returnFocusAfterClose: PropTypes.bool,
    focusFirstChildAfterOpen: PropTypes.bool,
    focusThisChildAfterOpen: PropTypes.string,
    style: PropTypes.shape({
      overlay: PropTypes.object,
      content: PropTypes.object,
    }),
    className: PropTypes.string,
    overlayClassName: PropTypes.string,
    role: PropTypes.string,
    label: PropTypes.string,
    labelledby: PropTypes.string,
    children: PropTypes.node,
  };

  static defaultStyles = {
    overlay: {
      position: 'fixed',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%',
      zIndex: '900',
    },
    content: {
      position: 'fixed',
      zIndex: '1000',
      outline: 0,
    },
  };

  static extraStyles = {
    overlay: {
      background: 'rgba(255, 255, 255, 0.5)',
    },
    content: {
      background: 'rgba(0, 0, 0, 0.1)',
      transition: '0.25s ease-out',
    },
  };

  componentDidMount() {
    if (this.props.isOpen) {
      this.open();
    }
  }

  componentDidUpdate(prevProps, prevState) {
    if (this.props.isOpen && !prevProps.isOpen) {
      this.open();
    } else if (!this.props.isOpen && prevProps.isOpen) {
      this.close();
    }
  }

  open = () => {
    if (this.props.returnFocusAfterClose) {
      focusManager.focusLater();
    }

    this.getInitialFocus();
  };

  close = () => {
    if (this.props.returnFocusAfterClose) {
      focusManager.returnFocus();
    }
  };

  getInitialFocus = () => {
    const { focusFirstChildAfterOpen, focusThisChildAfterOpen } = this.props;

    if (focusFirstChildAfterOpen) {
      focusManager.focusFirstChild(this.content);
    } else if (focusThisChildAfterOpen) {
      focusManager.focusChild(this.content, focusThisChildAfterOpen);
    } else {
      this.focusContent();
    }
  };

  parentHandlesClose = event => {
    if (this.props.onClose) {
      this.props.onClose(event);
    }
  };

  handleOverlayClick = event => {
    if (this.props.closeOnOverlayClick && event.target === this.overlay) {
      this.parentHandlesClose(event);
    }
  };

  handleKeyDown = event => {
    if (this.props.trapFocusAfterOpen) {
      if (event.keyCode === TAB_KEY) {
        focusTrap(event, this.content);
      }
    }

    if (this.props.closeOnEsc && event.keyCode === ESC_KEY) {
      this.parentHandlesClose(event);
    }
  };

  setOverlayRef = overlay => {
    this.overlay = overlay;
  };

  setContentRef = content => {
    this.content = content;
  };

  focusContent = () => this.content && this.content.focus();

  getExtraStyles = () => {
    const { className, overlayClassName } = this.props;

    // Remove extra styles when classNames are passed
    const overlayStyles = overlayClassName ? {} : OffCanvas.extraStyles.overlay;
    const contentStyles = className ? {} : OffCanvas.extraStyles.content;

    return {
      overlay: overlayStyles,
      content: contentStyles,
    };
  };

  getStyles = () => {
    const { isOpen, width, height, position, style } = this.props;
    const extraStyles = this.getExtraStyles();

    const styles = createStyles(
      OffCanvas.defaultStyles,
      extraStyles,
      isOpen,
      width,
      height,
      position,
      style,
    );

    return styles;
  };

  getPushStyles = () => {
    const { isOpen, width } = this.props;
    const pushStyles = createPushStyles(isOpen, width);
    return pushStyles;
  };

  pushStyles = (active = true) => {
    const { mainContainerSelector } = this.props;

    if (mainContainerSelector) {
      const pushStyles = this.getPushStyles();
      applyPushStyles(mainContainerSelector, pushStyles, active);
    }
  };

  render() {
    const {
      isOpen,
      role,
      label,
      labelledby,
      className,
      overlayClassName,
    } = this.props;

    this.pushStyles();
    const styles = this.getStyles();

    return (
      <div
        ref={this.setOverlayRef}
        style={styles.overlay}
        className={overlayClassName}
        onClick={this.handleOverlayClick}
        data-testid="overlay"
      >
        <div
          ref={this.setContentRef}
          style={styles.content}
          className={className}
          onKeyDown={this.handleKeyDown}
          role={role}
          aria-label={label}
          aria-labelledby={labelledby}
          aria-hidden={!isOpen}
          tabIndex="-1"
          data-testid="content"
        >
          {this.props.children}
        </div>
      </div>
    );
  }
}
 */


exports.default = OffCanvas;