"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runEventHandlerOnce = runEventHandlerOnce;
// Attaches an event handler to the specified element and ensures that the
// event handler is executed only once.
function runEventHandlerOnce(target, type, listener) {
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : { add: { capture: false }, remove: { capture: false } };

  function eventHandler(event) {
    event.target.removeEventListener(event.type, eventHandler, options.remove);
    listener(event);
  }
  target.addEventListener(type, eventHandler, options.add);
}